function [p_star,a_star,t_star] = findmax(V,F,tprev);

global W N PROFILES;

pl = kron((1:N),ones(PROFILES,1));
a  = kron(ones(1,N),(1:PROFILES)');

DV = zeros(PROFILES,N);
t  = zeros(PROFILES,N);
f  = zeros(PROFILES,N);

[V I] = newV(F,V,0,0);

for i = 1:PROFILES,
   for p = 1:N,
      f(i,p)  = F(i,p)==1 | F(my_neg(i,p),p)==1;
      DV(i,p) = V(my_neg(i,p),p) - V(i,p);
      if DV(i,p) < 0,
         t(i,p) = 0;
      elseif I(i,p) > 0,
         t(i,p) = tprev;
      else,
         t(i,p) = min([tprev Cinv(DV(i,p)/(1+I(my_neg(i,p),p)))]);
      end;   
   end;
end;   

t  = 1e-10*round(t*1e10);

a = reshape(a,PROFILES*N,1);
p = reshape(pl,PROFILES*N,1);
t = reshape(t,PROFILES*N,1);
f = reshape(f,PROFILES*N,1);

temp = [t p a f];
temp = temp(f==0,:);
temp = sortrows(temp);

t = temp(:,1);
p = temp(:,2);
a = temp(:,3);

l = length(t);
count = 0;
while t(l-count) == t(l),
   count = count+1;
   if count==l,
      break;
   end;   
end;

p_star = p(l+1-count:l);
a_star = a(l+1-count:l);
t_star = t(l);